        implicit none
        real*8 ms,m,x,y,z,rm,xmin,ymin,zmin,xmax,ymax,zmax
        real*8 vx,vy,vz,r,sm,v,w,dt,fakx,faky,fakz
        integer k,n,sys
        ALLOCATABLE m(:),x(:),y(:),z(:),rm(:),vx(:),vy(:),vz(:)
******* 2 x Sonnenmasse _kg        20_au _m   Schrittweite _s   ****
        data    ms/5.d30/,       r/2.99196d12/,   dt/86400.d0/
        write(*,'('' Anzahl Objekte ='',$)')
        read (*,*) n
        ALLOCATE(m(n),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE m'
        ALLOCATE(x(n),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE x'
        ALLOCATE(y(n),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE y'
        ALLOCATE(z(n),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE z'
        ALLOCATE(rm(n),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE rm'
        ALLOCATE(vx(n),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE vx'
        ALLOCATE(vy(n),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE vy'
        ALLOCATE(vz(n),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE vz'
********        Massen          *******
        sm=0.d0
        do k=1,n
        m(k)=(1.d0+0.1d-1*(rand()-0.5))
        sm=sm+m(k)
        end do
        do k=1,n
        m(k)=m(k)*ms/sm
        end do
        sm=0.d0
        do k=1,n
        sm=sm+m(k)
        end do
********        Radien          *******
        do k=1,n
        rm(k)=m(k)**0.333333333333d0
        end do
********    Masseansammlungen    *******
********    Levy  Klumpen        *******
        x(1)=0.d0
        y(1)=0.d0
        z(1)=0.d0
        do k=2,n
        w=1.d0+80.d0*rand()**4        ! **3,4,5,5.2
        v=0.3+rand()*0.4
        x(k)=x(k-1)+w*(rand()-v)
        y(k)=y(k-1)+w*(rand()-v)
        z(k)=z(k-1)+w*(rand()-v)
        end do
********    Dimensionieren       *******
        xmin=1.d250
        ymin=1.d250
        zmin=1.d250
        xmax=-xmin
        ymax=-ymin
        zmax=-zmin
        do k=1,n
        if(xmin.gt.x(k)) xmin=x(k)
        if(ymin.gt.y(k)) ymin=y(k)
        if(zmin.gt.z(k)) zmin=z(k)
        if(xmax.lt.x(k)) xmax=x(k)
        if(ymax.lt.y(k)) ymax=y(k)
        if(zmax.lt.z(k)) zmax=z(k)
        end do
        fakx=(r+r)/(xmax-xmin)
        faky=(r+r)/(ymax-ymin)
        fakz=(r+r)/(zmax-zmin)
********    Ausrichten           *******
        if(fakx.ge.faky.and.faky.ge.fakz) then
                do k=1,n
                w=x(k)
                x(k)=z(k)
                z(k)=w
                end do
                w=fakx
                fakx=fakz
                fakz=w
        else if(faky.ge.fakx.and.fakx.ge.fakz) then
                do k=1,n
                w=y(k)
                y(k)=z(k)
                z(k)=w
                end do
                w=faky
                faky=fakz
                fakz=w
        end if
        fakx=4.d0*fakx/3.d0
        do k=1,n
        x(k)=x(k)*fakx
        y(k)=y(k)*faky
        z(k)=z(k)*fakz
        end do
********     Schwerpunkt zu 0   ********
        fakx=0.d0
        faky=0.d0
        fakz=0.d0
        do k=1,n
        fakx=fakx+x(k)*m(k)
        faky=faky+y(k)*m(k)
        fakz=fakz+z(k)*m(k)
        end do
        fakx=fakx/sm
        faky=faky/sm
        fakz=fakz/sm
        do k=1,n
        x(k)=x(k)-fakx
        y(k)=y(k)-faky
        z(k)=z(k)-fakz
        end do
********     Geschwindigkeiten  ********
        do k=1,n
********     Turbulenzen        ********
        vx(k)=1.d3*(rand()-.5)
        vy(k)=1.d3*(rand()-.5)
        vz(k)=1.d3*(rand()-.5)
        end do
********        Datenausgabe    **********
        open (unit=1,file='grvknd.tmp',status='UNKNOWN')
        write(1,*)
     +  'Radieus_m',r,' Masse_kg',ms
        write(1,*) '     Masseansammlungen  dt_s'
        write(1,*) n,dt
        write(1,1)
1       format (7x,'m',14x,'rm',14x,'x',14x,'y',14x,'z',14x,
     +  'vz',14x,'vy',14x,'vz')
        do k=1,n
        write(1,'(8e16.8)')
     +  m(k),rm(k),x(k),y(k),z(k),vx(k),vy(k),vz(k)
        end do
        close (unit=1)
        close (unit=2)
        sys=system('mv grvknd.tmp grvknd.ini')
        end
