        implicit none
        logical initgrph
        character*1 inkey
        real*8 m,rm,x,y,z
        real*8 xx,yy,t,dauer,r,fk,al,dm
        real*8 maxx,maxy,minx,miny,fakx,faky,fak
        real*8 a,ax,ay,az,bx,by,bz,cx,cy,cz,dmax,tr(2,2)
        integer err,i,j,k,nn,n,zyk,frb,nz,feld(1240,720),na,je,indx
        real xu,yu,xo,yo,dx,dy,x1,y1,rn,w,v,u
        ALLOCATABLE frb(:),m(:),rm(:),x(:),y(:),z(:),nz(:),fk(:),al(:)
        data dm/0.d0/,indx/1/
        open (unit=1,file='trafo',status='OLD')
        read (1,*) nn   !,nz,fk,al
        ALLOCATE(nz(nn),STAT=err)
        if(err.ne.0) stop 'ALLOCATE nz'
        ALLOCATE(fk(nn),STAT=err)
        if(err.ne.0) stop 'ALLOCATE fk'
        ALLOCATE(al(nn),STAT=err)
        if(err.ne.0) stop 'ALLOCATE al'
        do n=1,nn
        read (1,*) nz(n),fk(n),al(n)
        end do
        close (unit=1)
        call zykn(n,zyk)
        write(*,*) 'zyk',zyk,' n',n
        open
     +  (unit=2,file='video.vid',status='UNKNOWN',form='UNFORMATTED')
        open (unit=1,file='kollgal.pkt',status='OLD',form='UNFORMATTED')
        write(2) zyk-1,1240,720
        ALLOCATE(frb(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE frb'
        ALLOCATE(x(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE x'
        ALLOCATE(y(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE y'
        ALLOCATE(z(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE z'
        ALLOCATE(rm(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE rm'
        ALLOCATE(m(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE m'
        read (1) n,dauer,(frb(i),i=1,n),
     +  (m(i),i=1,n),(rm(i),i=1,n),
     +  (x(i),i=1,n),(y(i),i=1,n),(z(i),i=1,n)
        if(dm.eq.0.d0) then
                do i=1,n
                dm=dm+m(i)
                end do
                dm=dm/dfloat(n)
                na=n
        end if
        minx=1.d250
        miny=1.d250
        maxx=-minx
        maxy=-miny
        call prjkt(k,zyk,ax,ay,az,bx,by,bz,cx,cy,cz)
        do i=1,n
         xx=ax*x(i)+ay*y(i)+az*z(i)
         yy=bx*x(i)+by*y(i)+bz*z(i)
         if(maxx.lt.xx) maxx=xx
         if(maxy.lt.yy) maxy=yy
         if(minx.gt.xx) minx=xx
         if(miny.gt.yy) miny=yy
        end do
        dmax=0.25d0*(maxx-minx)
        maxx=maxx+dmax
        minx=minx-dmax
        dmax=0.25d0*(maxy-miny)
        maxy=maxy+dmax
        miny=miny-dmax
        fakx=1240.d0/(maxx-minx)
        faky=720.d0/(maxy-miny)
        minx=fakx*minx
        miny=faky*miny
        maxx=fakx*maxx
        maxy=faky*maxy
        dx=620.d0
        dy=360.d0
        write(*,*) minx,miny,maxx,maxy,dx,dy
        if(.not.initgrph(10,10,1240,720)) stop
        xu=0.
        yu=0.
        xo=1240.
        yo=720.
        call fenster(.true.,xu,yu,xo,yo)
        rewind 1
        do k=0,zyk
         call trafo(k,nn,nz,fk,al,fak,tr)
         read (1) n,t,(frb(i),i=1,n),
     +   (m(i),i=1,n),(rm(i),i=1,n),
     +   (x(i),i=1,n),(y(i),i=1,n),(z(i),i=1,n)
         call prjkt(k,zyk,ax,ay,az,bx,by,bz,cx,cy,cz)
         do i=1,n
          xx=fakx*(ax*x(i)+ay*y(i)+az*z(i))
          yy=faky*(bx*x(i)+by*y(i)+bz*z(i))
          x1=dx+fak*(tr(1,1)*xx+tr(1,2)*yy)
          y1=dy+fak*(tr(2,1)*xx+tr(2,2)*yy)
          if(x1.lt.xu+5.) goto 3
          if(y1.lt.yu+5.) goto 3
          if(x1.gt.xo-5.) goto 3
          if(y1.gt.yo-5.) goto 3
          call farb(-1)
          je=3+2.*rand()+dfloat(na)/dfloat(n)
          if(m(i).gt.5.d0*dm) je=je+je
          do j=1,je
          v=fak*(6.+6.*rand())
          w=v*(rand()-.5)
          u=v*(rand()-.5)
          x1=x1+w
          y1=y1+u
          call stpkt(x1,y1)
          end do
3         continue
         end do
         call prjkt(k,zyk,ax,ay,az,bx,by,bz,cx,cy,cz)
         do i=1,n
          xx=fakx*(ax*x(i)+ay*y(i)+az*z(i))
          yy=faky*(bx*x(i)+by*y(i)+bz*z(i))
          x1=dx+fak*(tr(1,1)*xx+tr(1,2)*yy)
          y1=dy+fak*(tr(2,1)*xx+tr(2,2)*yy)
          if(x1.lt.xu+5.) goto 4
          if(y1.lt.yu+5.) goto 4
          if(x1.gt.xo-5.) goto 4
          if(y1.gt.yo-5.) goto 4
          call farb(frb(i))
          call stpkt(x1,y1)
4         continue
         end do
         call getimage(1240,720,feld)
         call rgbmp (indx,1240,720,feld)
         call xrcls ()
        end do
        call endgrphc()
        close (unit=1)
        end
        subroutine prjkt(k,zyk,ax,ay,az,bx,by,bz,cx,cy,cz)
        implicit none
        integer k,zyk,zk
        real*8 ax,ay,az,bx,by,bz,cx,cy,cz,w
        zk=1800
        w=3.14159265359d0*2.d0/3.d0
        ax=1.d0
        ay=0.d0
        az=0.d0
        bx=0.d0
        by=dcos(w)
        bz=dsin(w)
        cx=ay*bz-az*by
        cy=az*bx-ax*bz
        cz=ax*by-ay*bx
        return
        end
        subroutine zykn(n,zyk)
        implicit none
        integer i,n,zyk,nn
        real*8 w
        n=0
        zyk=0
        open (unit=1,file='kollgal.pkt',status='OLD',form='UNFORMATTED')
1       continue
        read (1,err=2,end=2)
     +  nn,w,(w,i=1,nn),(w,i=1,nn),(w,i=1,nn),(w,i=1,nn)
        if(n.lt.nn) n=nn
        zyk=zyk+1
        goto 1
2       continue
        close (unit=1)
        zyk=zyk-1
        return
        end
        subroutine farb(frb)
        implicit none
        real w
        integer frb,rr,gg,bb,rgb
        common/rrggbb/rr,gg,bb
        if(frb.gt.0) then
                rgb=frb-1000*(frb/1000)
        else
                rgb=frb
        end if
        if(frb.gt.900) rgb=12
        w=rand()
        if(rgb.eq.15) then
                rr=120+w*130
                gg=120+w*130
                bb=120+w*130
        else if(rgb.eq.14) then
                rr=250
                gg=250
                bb=w*50
        else if(rgb.eq.12) then
                rr=255
                gg=50+w*30
                bb=50+w*30
        else if(rgb.eq.1) then
                rr=50+w*30
                gg=50+w*30
                bb=255
        else if(rgb.lt.0) then
                rr=75
                gg=75
                bb=75
        else
                rr=0
                gg=0
                bb=0
        end if
        return
        end
        subroutine stpkt(x1,y1)
        implicit none
        real x1,y1,w
        integer rr,gg,bb
        common/rrggbb/rr,gg,bb
        if(rr.lt.255.and.bb.lt.255) then
                call setipix (int(x1+.5),int(y1+.5),rr,gg,bb)
        else
                call vllkrs(x1,y1,1.2)
        end if
        return
        end
        subroutine vllkrs(x1,y1,w)
        implicit none
        integer i,j,rr,gg,bb
        common/rrggbb/rr,gg,bb
        real x1,y1,w
        do i=-int(w+.5),int(w+.5)
        do j=-int(w+.5),int(w+.5)
        if(float(i)**2+float(j)**2.le.w**2)
     +  call setipix (int(x1)+i,int(y1)+j,rr,gg,bb)
        end do
        end do
        return
        end
        subroutine trafo(k,nn,nz,fk,al,fak,tr)
        implicit none
        integer i,k,nn,nz(nn)
        real*8 fk(nn),al(nn),fak,tr(2,2),alpha
        do i=1,nn
        if(nz(i).le.k) then
                fak=fk(i)
                alpha=al(i)
        end if
        end do
        tr(1,1)=dcos(alpha)
        tr(1,2)=-dsin(alpha)
        tr(2,1)=dsin(alpha)
        tr(2,2)=dcos(alpha)
        return
        end

