        implicit none
        logical weiter,wiederanlauf,halt
        real*8 dt,t,r0
        real*8 gf,sm
        real*8 m,x,y,z,rm,xki,yki,zki,xm,ym,zm,ms
        real*8 vx,vy,vz,bx,by,bz,a,r,rn,vxn,vyn,vzn
        integer err,i,k,n,nz,n1,sys
        character*8 a1
        character*9 a2
        ALLOCATABLE m(:),x(:),y(:),z(:),vx(:),vy(:),vz(:),rm(:)
        weiter=wiederanlauf()
        write(*,*) ' Achtung: je nach Anzahl der Objekte'
        write(*,*)
     +  ' lange Rechenzeit; Wiederanlauf möglich und empfohlen.'
        write(*,*) ' Unterbrechung:'
        write(*,*) ' 1.neues Fenster öffnen'
        write(*,*) ' 2.ins aktuelle Verzeichnis wechseln'
        write(*,*) ' 3.Datei mit Namen halt einrichten, Inhalt beliebig'
        open (unit=1,file='grvknd.ini',status='OLD')
        read (1,*) a1,r0,a2,sm
        write(*,*) a1,r0,a2,sm
        read (1,*)
        read (1,*) n,dt
        n1=n/20
        nz=0
        t=0.d0
        write(*,*) ' Masseansammlungen',n,' dt',dt
        ALLOCATE(m(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE m'
        ALLOCATE(rm(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE rm'
        ALLOCATE(x(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE x'
        ALLOCATE(y(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE y'
        ALLOCATE(z(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE z'
        ALLOCATE(vx(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE vx'
        ALLOCATE(vy(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE vy'
        ALLOCATE(vz(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE vz'
        read (1,*) ! 'm',14x,'rm',14x,'x',14x,'y',14x,'z',14x,'vz',14x,'vy',14x,'vz')
        do k=1,n
        read (1,*) m(k),rm(k),x(k),y(k),z(k),vx(k),vy(k),vz(k)
        end do
        close (unit=1)
        if(weiter) then
                call aktuell(t,nz,n,m,rm,x,y,z,vx,vy,vz)
        else
        open
     +  (unit=1,file='grvknd.tmp',status='UNKNOWN',form='UNFORMATTED')
        end if
        do while(n.gt.n1.and.nz.lt.24001)
         if(nz.eq.10*(nz/10)) then
                i=nz/10
                write(1) n,t,(m(k),k=1,n),(rm(k),k=1,n),
     +          (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +          (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
                write(*,*) i,dt,t,n,n1
                if(halt()) then
                        close (unit=1)
                        close (unit=2)
                        call massen(n,m)
                        stop 'halt'
                end if
         end if
         call kollision(n,m,rm,x,y,z,vx,vy,vz)
         do k=1,n-1
          do i=k+1,n
           xki=x(k)-x(i)
           yki=y(k)-y(i)
           zki=z(k)-z(i)
           r=dsqrt(xki**2+yki**2+zki**2)
           r=r+rm(i)+rm(k)
           a=-gf(r)*dt/r
           bx=xki*a
           by=yki*a
           bz=zki*a
           vx(k)=vx(k)+bx*m(i)
           vy(k)=vy(k)+by*m(i)
           vz(k)=vz(k)+bz*m(i)
           vx(i)=vx(i)-bx*m(k)
           vy(i)=vy(i)-by*m(k)
           vz(i)=vz(i)-bz*m(k)
          end do
         end do
         do k=1,n
          x(k)=x(k)+dt*vx(k)
          y(k)=y(k)+dt*vy(k)
          z(k)=z(k)+dt*vz(k)
         end do
         t=t+dt
         nz=nz+1
         ms=0.d0
         xm=0.d0
         ym=0.d0
         zm=0.d0
         do k=1,n
         ms=ms+m(k)
         xm=xm+x(k)*m(k)
         ym=ym+y(k)*m(k)
         zm=zm+z(k)*m(k)
         end do
         xm=xm/ms
         ym=ym/ms
         zm=zm/ms
         do k=1,n
         x(k)=x(k)-xm
         y(k)=y(k)-ym
         z(k)=z(k)-zm
         end do
        end do
        close (unit=1)
        close (unit=2)
        call massen(n,m)
        sys=system('cp grvknd.tmp grvknd.pkt')
        sys=system('rm grvknd.tmp')
        end
        real*8 function gf(r)
        implicit none
        real*8 r
        gf=(2.384243748582d-30+6.6742d-11/r)/r
        return
        end
        subroutine kollision(n,m,rm,x,y,z,vx,vy,vz)
        implicit none
        integer i,ji,jk,k,n
        real*8 m(n),rm(n),x(n),y(n),z(n),vx(n),vy(n),vz(n),w
        do k=1,n-1
         do i=k+1,n
          if(dsqrt((x(k)-x(i))**2+(y(k)-y(i))**2+(z(k)-z(i))**2).lt.
     +          rm(k)+rm(i)) then
                ji=i
                jk=k
*       Impulserhaltung & Energieumwandlung (kin.Energ. => ...)
                x(jk)=(m(jk)*x(jk)+m(ji)*x(ji))/(m(jk)+m(ji))
                y(jk)=(m(jk)*y(jk)+m(ji)*y(ji))/(m(jk)+m(ji))
                z(jk)=(m(jk)*z(jk)+m(ji)*z(ji))/(m(jk)+m(ji))
                vx(jk)=(m(jk)*vx(jk)+m(ji)*vx(ji))/(m(jk)+m(ji))
                vy(jk)=(m(jk)*vy(jk)+m(ji)*vy(ji))/(m(jk)+m(ji))
                vz(jk)=(m(jk)*vz(jk)+m(ji)*vz(ji))/(m(jk)+m(ji))
                m(jk)=m(jk)+m(ji)
                rm(jk)=(rm(jk)**3+rm(ji)**3)**0.333333333333d0
                call aufruecken(n,ji,m,rm,x,y,z,vx,vy,vz)
          end if
         end do
        end do
        return
        end
        subroutine aufruecken(n,ji,m,rm,x,y,z,vx,vy,vz)
        implicit none
        integer ji,k,n
        real*8 m(n),rm(n),x(n),y(n),z(n),vx(n),vy(n),vz(n)
        if(n.eq.1) return
        if(ji.lt.n) then
                do k=ji,n-1
                m(k)=m(k+1)
                rm(k)=rm(k+1)
                x(k)=x(k+1)
                y(k)=y(k+1)
                z(k)=z(k+1)
                vx(k)=vx(k+1)
                vy(k)=vy(k+1)
                vz(k)=vz(k+1)
                end do
        end if
        n=n-1
        return
        end
        logical function wiederanlauf()
        implicit none
        open (
     +  unit=1,file='grvknd.tmp',status='OLD',form='UNFORMATTED',err=1)
        wiederanlauf=.true.
        close (unit=1)
        return
1       continue
        wiederanlauf=.false.
        close (unit=1)
        return
        end
        subroutine aktuell(t,nz,n,m,rm,x,y,z,vx,vy,vz)
        implicit none
        integer i,k,n,nz
        real*8 tt,t,m(n),rm(n),x(n),y(n),z(n),vx(n),vy(n),vz(n)
        open (
     +  unit=1,file='grvknd.tmp',status='OLD',form='UNFORMATTED')
        open (
     +  unit=2,file='grvknd.pkt',status='UNKNOWN',form='UNFORMATTED')
1       continue
        read (1,err=2,end=2) n,tt,(m(k),k=1,n),(rm(k),k=1,n),
     +  (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +  (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
        if(tt.gt.t) t=tt
        write(2) n,tt,(m(k),k=1,n),(rm(k),k=1,n),
     +  (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +  (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
        goto 1
2       continue
        close (unit=1)
        close (unit=2)
        open (
     +  unit=2,file='grvknd.pkt',status='OLD',form='UNFORMATTED')
        open (
     +  unit=1,file='grvknd.tmp',status='UNKNOWN',form='UNFORMATTED')
3       continue
        read (2,err=4,end=4) n,tt,(m(k),k=1,n),(rm(k),k=1,n),
     +  (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +  (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
        read (2,err=4,end=4) k
        backspace 2
        write(1) n,tt,(m(k),k=1,n),(rm(k),k=1,n),
     +  (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +  (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
        nz=nz+10
        goto 3
4       continue
        close (unit=2)
        write(*,*) 'wiederanlauf mit nz=',nz
        return
        end
        logical function halt()
        open (unit=3,file='halt',status='OLD',err=1)
        halt=.true.
        close (unit=3,status='DELETE')
        return
1       continue
        halt=.false.
        close (unit=3)
        return
        end
        subroutine massen(n,m)
        implicit none
        integer i,j,k,n
        real*8 m(n),w
        do k=1,n-1
         do i=k+1,n
          if(m(k).lt.m(i)) then
                  w=m(k)
                  m(k)=m(i)
                  m(i)=w
          end if
         end do
        end do
        open (unit=4,file='massen',status='UNKNOWN')
        write(4,'(10f8.5)') (m(k)/2.d30,k=1,100)
        close (unit=4)
        k=system('cp grvknd.tmp grvknd.pkt')
        return
        end
