        implicit none
        real*8 alpha,pi,xx,yy,zz,wa,wb,spirale
        real*8 ms,c,m,x,y,z,rm
        real*8 vx,vy,vz,a,r,sm,v,w,xm,ym,zm,dr,dv
        integer jj,k,n,frb,sys
        data wa/0.4d0/,wb/0.1d0/,
     +  ms/2.d41/c/299792458.d0/,pi/3.14159265359d0/
        ALLOCATABLE m(:),x(:),y(:),z(:),rm(:),vx(:),vy(:),vz(:),frb(:)
        write(*,'('' Anzahl Masseansammlungen='',$)')
        read (*,*) jj
        write(*,*) 'Galaxie 1',4*jj/7,' Galaxie 2',3*jj/7
        ALLOCATE(m(jj),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE m'
        ALLOCATE(x(jj),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE x'
        ALLOCATE(y(jj),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE y'
        ALLOCATE(z(jj),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE z'
        ALLOCATE(vx(jj),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE vx'
        ALLOCATE(vy(jj),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE vy'
        ALLOCATE(vz(jj),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE vz'
        ALLOCATE(rm(jj),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE mr'
        ALLOCATE(frb(jj),STAT=sys)
        if(sys.ne.0) stop 'ALLOCATE frb'
********        erste Galaxie   ********
        n=4*jj/7
        v=ms/dfloat(n)
        k=0
        r=dsqrt(.75d0)*4.5d20
        dr=r/1.d3
        dv=0.d0
        do k=1,n
         w=rand()
         frb(k)=15
         if(w.gt.0.95d0) then
                frb(k)=1
         else if(w.lt.0.6d0) then
                frb(k)=14
         end if
         m(k)=(.9d0+0.6d0*(rand()-0.5))*v
         rm(k)=1.2d20*(m(k)/ms)**.33333333333333
********        Masseansammlungen       ************
         a=r*(rand()+0.01)
         alpha=2.d0*pi*rand()
         x(k)=a*dcos(alpha)
         y(k)=a*dsin(alpha)
         a=0.03d0*r
         if(x(k)**2+y(k)**2.lt.0.30d0*r**2) then
          z(k)=(rand()-0.5)*(dsqrt(0.30d0*r**2-x(k)**2-y(k)**2)+a)
         else
          z(k)=2.d0*(rand()-0.5)*a
         end if
         vx(k)=(1.+0.1*rand())*c*0.0021*y(k)/r
         vy(k)=-(1.+0.1*rand())*c*0.0021*x(k)/r
         vz(k)=-(1.+0.1*(rand()-0.5))*c*0.00002*z(k)/r
         a=dsqrt(vx(k)**2+vy(k)**2+vz(k)**2)
         if(a.gt.dv) dv=a
        end do
        dv=dv/1.d3
********        zweite Galaxie   *******
        r=dsqrt(.5d0)*4.5d20
        do k=n+1,jj
         w=rand()
         frb(k)=15
         if(w.gt.0.95d0) then
                frb(k)=1
         else if(w.lt.0.6d0) then
                frb(k)=14
         end if
         m(k)=(.9d0+0.6d0*(rand()-0.5))*v
         rm(k)=1.2d20*(m(k)/ms)**.33333333333333
********        Masseansammlungen       ************
         a=r*(rand()+0.01)
         alpha=2.d0*pi*rand()
         x(k)=a*dcos(alpha)
         y(k)=a*dsin(alpha)
         a=0.03d0*r
         if(x(k)**2+y(k)**2.lt.0.30d0*r**2) then
          z(k)=(rand()-0.5)*(dsqrt(0.30d0*r**2-x(k)**2-y(k)**2)+a)
         else
          z(k)=2.d0*(rand()-0.5)*a
         end if
         vx(k)=(1.+0.1*rand())*c*0.0019*y(k)/r
         vy(k)=-(1.+0.1*rand())*c*0.0019*x(k)/r
         vz(k)=-(1.+0.1*(rand()-0.5))*c*0.00002*z(k)/r
        end do
        do k=n+1,jj
********        Transformation  *********
********        Drehung         *********
         xx=dcos(wa)*dcos(wb)*x(k)+dsin(wa)*dcos(wb)*y(k)+dsin(wb)*z(k)
         yy=-dcos(wa)*dsin(wb)*x(k)-dsin(wa)*dsin(wb)*y(k)+dcos(wb)*z(k)
         zz=-dsin(wa)*x(k)+dcos(wa)*y(k)
         x(k)=xx
         y(k)=yy
         z(k)=zz
         xx=cos(.5)*cos(.3)*vx(k)+sin(.5)*cos(.3)*vy(k)+sin(.3)*vz(k)
         yy=-cos(.5)*sin(.3)*vx(k)-sin(.5)*sin(.3)*vy(k)+cos(.3)*vz(k)
         zz=-sin(.5)*vx(k)+cos(.5)*vy(k)
         vx(k)=xx
         vy(k)=yy
         vz(k)=zz
        end do
********        Verschiebung    *********
        do k=n+1,jj
         z(k)=z(k)-r
         y(k)=y(k)+r+r
         x(k)=x(k)+13.d0*r
********        Koll.-Geschw.   *********
         vx(k)=vx(k)-0.0001d0*c
         vy(k)=vy(k)-0.00001d0*c
         vz(k)=vz(k)+0.00001d0*c
        end do
********        zentrieren      ***********
        n=jj
        xm=0.d0
        ym=0.d0
        zm=0.d0
        sm=0.d0
        do k=1,n
        sm=sm+m(k)
        xm=xm+m(k)*x(k)
        ym=ym+m(k)*y(k)
        zm=zm+m(k)*z(k)
        end do
        xm=xm/sm
        ym=ym/sm
        zm=zm/sm
        do k=1,n
        x(k)=x(k)-xm
        y(k)=y(k)-ym
        z(k)=z(k)-zm
        end do
********        Datenausgabe    **********
        open (unit=1,file='kollgal.tmp',status='UNKNOWN')
        write(1,*) '     Punkte        dt_s     dr_m    dv_m/_s'
        write(1,*) n,1262277038988.d0,dr,dv   ! 40000_yr
        write(1,1)
1       format (' frb'14x,'m',14x,'rm',14x,'x',14x,'y',14x,'z',14x,
     +  'vz',14x,'vy',14x,'vz')
        do k=1,n
        write(1,'(i4,2x,8e16.8)')
     +  frb(k),m(k),rm(k),x(k),y(k),z(k),vx(k),vy(k),vz(k)
        end do
        close (unit=1)
        close (unit=2)
        sys=system('mv kollgal.tmp kollgal.ini')
        end
