        implicit none
        logical weiter,wiederanlauf,halt
        real*8 dt,t,dr,dv
        real*8 gf
        real*8 m,x,y,z,rm,xki,yki,zki,xm,ym,zm,ms
        real*8 vx,vy,vz,bx,by,bz,a,r,rn,vxn,vyn,vzn
        integer err,i,k,n,nz,sys,frb
        common/neza/zaehler,nenner
        real*8 zaehler,nenner
        ALLOCATABLE frb(:),m(:),x(:),y(:),z(:),vx(:),vy(:),vz(:),rm(:)
        weiter=wiederanlauf()
        write(*,*) ' Achtung: je nach Anzahl der Objekte'
        write(*,*)
     +  ' lange Rechenzeit; Wiederanlauf möglich und empfohlen.'
        write(*,*) ' Unterbrechung:'
        write(*,*) ' 1.neues Fenster öffnen'
        write(*,*) ' 2.dort ins aktuelle Verzeichnis wechseln'
        write(*,*)
     +  ' 3.dort Datei mit Namen halt einrichten, Inhalt beliebig'
        open (unit=1,file='kollgal.ini',status='OLD')
        read (1,*)      !       n dt dr dv
        read (1,*) n,dt,dr,dv
        nz=0
        t=0.d0
        write(*,*) ' Masseansammlungen',n,' dt',dt,' dr',dr,' dv',dv
        ALLOCATE(frb(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE frb'
        ALLOCATE(m(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE m'
        ALLOCATE(rm(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE rm'
        ALLOCATE(x(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE x'
        ALLOCATE(y(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE y'
        ALLOCATE(z(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE z'
        ALLOCATE(vx(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE vx'
        ALLOCATE(vy(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE vy'
        ALLOCATE(vz(n),STAT=err)
        if(err.ne.0) stop 'ALLOCATE vz'
        read (1,*) ! 'm',14x,'rm',14x,'x',14x,'y',14x,'z',14x,'vz',14x,'vy',14x,'vz')
*       frb   m     rm     x     y      z     vz     vy      vz
        do k=1,n
        read (1,*) frb(k),m(k),rm(k),x(k),y(k),z(k),vx(k),vy(k),vz(k)
        end do
        close (unit=1)
        if(weiter) then
                call aktuell(t,nz,n,frb,m,rm,x,y,z,vx,vy,vz)
        else
        open
     +  (unit=1,file='kollgal.tmp',status='UNKNOWN',form='UNFORMATTED')
        end if
        xm=0.d0
        ym=0.d0
        zm=0.d0
        zaehler=0.d0
        nenner=1.d-5
        do while(nz.lt.18001)
         if(nz.eq.10*(nz/10)) then
                i=nz/10
                write(1) n,t,(frb(k),k=1,n),
     +          (m(k),k=1,n),(rm(k),k=1,n),
     +          (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +          (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
                write(*,*)
     +  i,dt,t,n,int(zaehler+.5d0),' von',int(nenner+.5d0)
                zaehler=0.d0
                nenner=1.d-5
                if(halt()) then
                        close (unit=1)
                        sys=system('cp kollgal.tmp kollgal.pkt')
                        stop 'halt'
                end if
         end if
         do k=1,n
         frb(k)=frb(k)-1000*(frb(k)/1000)
         end do
         do k=1,n-1
          do i=k+1,n
           xki=x(k)-x(i)
           yki=y(k)-y(i)
           zki=z(k)-z(i)
           r=dsqrt(xki**2+yki**2+zki**2)
           if(r.lt.rm(i)+rm(k))
     +     call kollision(dr,dv,r,rm(k)+rm(i),frb(k),frb(i),m(k),m(i),
     +                  vx(k),vy(k),vz(k),vx(i),vy(i),vz(i))
           r=r+rm(i)+rm(k)
           a=-gf(r)*dt/r
           bx=xki*a
           by=yki*a
           bz=zki*a
           vx(k)=vx(k)+bx*m(i)
           vy(k)=vy(k)+by*m(i)
           vz(k)=vz(k)+bz*m(i)
           vx(i)=vx(i)-bx*m(k)
           vy(i)=vy(i)-by*m(k)
           vz(i)=vz(i)-bz*m(k)
          end do
         end do
         call verschmelzen(n,dr,dv,frb,m,rm,x,y,z,vx,vy,vz)
         do k=1,n
          x(k)=x(k)+dt*vx(k)
          y(k)=y(k)+dt*vy(k)
          z(k)=z(k)+dt*vz(k)
         end do
         t=t+dt
         nz=nz+1
         ms=0.d0
         xm=0.d0
         ym=0.d0
         zm=0.d0
         do k=1,n
         ms=ms+m(k)
         xm=xm+x(k)*m(k)
         ym=ym+y(k)*m(k)
         zm=zm+z(k)*m(k)
         end do
         xm=xm/ms
         ym=ym/ms
         zm=zm/ms
         do k=1,n
         x(k)=x(k)-xm
         y(k)=y(k)-ym
         z(k)=z(k)-zm
         end do
        end do
        close (unit=1)
        sys=system('cp kollgal.tmp kollgal.pkt')
        sys=system('rm kollgal.tmp')
        end
        real*8 function gf(r)
        implicit none
        real*8 r
        gf=(2.384243748582d-30+6.6742d-11/r)/r
*           dunkle Materie    +Gravitation
        return
        end
        integer function modi(frb)
        implicit none
        integer frb,a
        a=frb-(frb/1000)*1000
        modi=a+1000
        return
        end
        logical function wiederanlauf()
        implicit none
        open (
     +  unit=1,file='kollgal.tmp',status='OLD',form='UNFORMATTED',err=1)
        wiederanlauf=.true.
        close (unit=1)
        return
1       continue
        wiederanlauf=.false.
        close (unit=1)
        return
        end
        subroutine aktuell(t,nz,n,frb,m,rm,x,y,z,vx,vy,vz)
        implicit none
        integer i,k,n,nz,frb(n)
        real*8 tt,t,m(n),rm(n),x(n),y(n),z(n),vx(n),vy(n),vz(n)
        open (
     +  unit=1,file='kollgal.tmp',status='OLD',form='UNFORMATTED')
        open (
     +  unit=2,file='kollgal.pkt',status='UNKNOWN',form='UNFORMATTED')
1       continue
        read (1,err=2,end=2) n,tt,(frb(k),k=1,n),
     +  (m(k),k=1,n),(rm(k),k=1,n),
     +  (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +  (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
        if(tt.gt.t) t=tt
        write(2) n,tt,(frb(k),k=1,n),
     +  (m(k),k=1,n),(rm(k),k=1,n),
     +  (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +  (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
        goto 1
2       continue
        close (unit=1)
        close (unit=2)
        open (
     +  unit=2,file='kollgal.pkt',status='OLD',form='UNFORMATTED')
        open (
     +  unit=1,file='kollgal.tmp',status='UNKNOWN',form='UNFORMATTED')
3       continue
        read (2,err=4,end=4) n,tt,(frb(k),k=1,n),
     +  (m(k),k=1,n),(rm(k),k=1,n),
     +  (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +  (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
        read (2,err=4,end=4) k
        backspace 2
        write(1) n,tt,(frb(k),k=1,n),
     +  (m(k),k=1,n),(rm(k),k=1,n),
     +  (x(k),k=1,n),(y(k),k=1,n),(z(k),k=1,n),
     +  (vx(k),k=1,n),(vy(k),k=1,n),(vz(k),k=1,n)
        nz=nz+10
        goto 3
4       continue
        close (unit=2)
        write(*,*) 'wiederanlauf mit nz=',nz
        return
        end
        logical function halt()
        open (unit=3,file='halt',status='OLD',err=1)
        halt=.true.
        close (unit=3,status='DELETE')
        return
1       continue
        halt=.false.
        close (unit=3)
        return
        end
        subroutine kollision
     +  (dr,dv,r,d,fk,fi,mk,mi,vxk,vyk,vzk,vxi,vyi,vzi) ! ???
        implicit none
        real*8 dr,dv,r,d,mk,mi,vxk,vyk,vzk,vxi,vyi,vzi,vxd,vyd,vzd,fak,w
        integer fk,fi,modi
        common/neza/zaehler,nenner
        real*8 zaehler,nenner
        nenner=nenner+1.d0
        w=(vxk*vxi+vyk*vyi+vzk*vzi)
        if(w.gt.0.d0) return            ! konform
        fak=r/d
        vxd=(mk*vxk+mi*vxi)/(mk+mi)     ! Impulserhaltung
        vyd=(mk*vyk+mi*vyi)/(mk+mi)     !       "
        vzd=(mk*vzk+mi*vzi)/(mk+mi)     !       "
        vxk=fak*vxk+(1.d0-fak)*vxd
        vyk=fak*vyk+(1.d0-fak)*vyd
        vzk=fak*vzk+(1.d0-fak)*vzd
        vxi=fak*vxi+(1.d0-fak)*vxd
        vyi=fak*vyi+(1.d0-fak)*vyd
        vzi=fak*vzi+(1.d0-fak)*vzd
        fk=modi(fk)
        fi=modi(fi)
        zaehler=zaehler+1.d0
        return
        end
        subroutine verschmelzen(n,dr,dv,frb,m,rm,x,y,z,vx,vy,vz)
        implicit none
        integer i,ji,jk,k,n,frb(n)
        real*8 m(n),rm(n),x(n),y(n),z(n),vx(n),vy(n),vz(n),w,dr,dv
        do k=1,n-1
         do i=k+1,n
          if(dsqrt((vx(k)-vx(i))**2+(vy(k)-vy(i))**2+(vz(k)-vz(i))**2)
     +          .lt.dv) then
           if(dsqrt((x(k)-x(i))**2+(y(k)-y(i))**2+(z(k)-z(i))**2).lt.dr)
     +           then
                ji=i
                jk=k
*       Impulserhaltung & Energieumwandlung (kin.Energ. => ...)
                x(jk)=(m(jk)*x(jk)+m(ji)*x(ji))/(m(jk)+m(ji))
                y(jk)=(m(jk)*y(jk)+m(ji)*y(ji))/(m(jk)+m(ji))
                z(jk)=(m(jk)*z(jk)+m(ji)*z(ji))/(m(jk)+m(ji))
                vx(jk)=(m(jk)*vx(jk)+m(ji)*vx(ji))/(m(jk)+m(ji))
                vy(jk)=(m(jk)*vy(jk)+m(ji)*vy(ji))/(m(jk)+m(ji))
                vz(jk)=(m(jk)*vz(jk)+m(ji)*vz(ji))/(m(jk)+m(ji))
                m(jk)=m(jk)+m(ji)
                rm(jk)=(rm(jk)**3+rm(ji)**3)**0.333333333333d0
                call aufruecken(n,ji,frb,m,rm,x,y,z,vx,vy,vz)
           end if
          end if
         end do
        end do
        return
        end
        subroutine aufruecken(n,ji,frb,m,rm,x,y,z,vx,vy,vz)
        implicit none
        integer ji,k,n,frb(n)
        real*8 m(n),rm(n),x(n),y(n),z(n),vx(n),vy(n),vz(n)
        if(n.eq.1) return
        if(ji.lt.n) then
                do k=ji,n-1
                frb(k)=frb(k+1)
                m(k)=m(k+1)
                rm(k)=rm(k+1)
                x(k)=x(k+1)
                y(k)=y(k+1)
                z(k)=z(k+1)
                vx(k)=vx(k+1)
                vy(k)=vy(k+1)
                vz(k)=vz(k+1)
                end do
        end if
        n=n-1
        return
        end
